﻿// PARTICLE EXPERIMENTS
// Author : Seb Lee-Delisle
// Blog : www.sebleedelisle.com
// Company : www.pluginmedia.net
//
// This work is licensed under a Creative Commons  2.0 License.

// Full details at 
// http://creativecommons.org/licenses/by/2.0/uk/

// You may re-use this code as you wish, but a credit would be 
// appreciated. And I'd love to see what you do with it! 
// mail me : seb@sebleedelisle.com

package 
{

import flash.display.*;	
	
public class Particle 
{ 

	public var xVel					:	Number; 		// the x and y velocity of the particle
	public var yVel					:	Number;
	
	public var drag					:	Number = 1; 		// the drag factor between 0 and 1, where 1 is no drag, and 0 is max drag. 
	
	public var fade					:	Number = 0;		// the fade factor, works as a multiplier. 
	
	public var shrink				:	Number = 1;		// another multiplier that changes the size. 
																	// If < 1 then the particle graphic shrinks, >1 and the particle grows. 
	
	public var gravity				:	Number = 0;		// the amount of gravity to add to the yVelocity every frame. If < 0 
																	// then gravity goes upwards. 
	
	public var clip:DisplayObject;					// display object for the particle
	
	public function Particle ( spriteclass : Class, targetclip : DisplayObjectContainer, xpos : Number, ypos : Number)
	{
		
		// instantiate a new particle graphic
		clip = new spriteclass(); 
		
		// and add it to the stage
		targetclip.addChild(clip); 
		
		// and set its position
		clip.x = xpos;
		clip.y = ypos;

	}
	
	public function setVel(xvel:Number, yvel:Number)
	{
		xVel = xvel;
		yVel = yvel;
	}
	
	public function setScale(newscale:Number)
	{
		clip.scaleX = clip.scaleY = newscale;
	}
	
	public function update()
	{
		
		// add the velocity to the particle's position... 
		clip.x += xVel;
		clip.y += yVel;
		
		// apply drag
		xVel*=drag;
		yVel*=drag;
		
		// fade out
		clip.alpha -=fade;
		
		// scale
		clip.scaleX = clip.scaleY *=shrink;
		
		// gravity
		yVel+=gravity;
		
	}
	
	public function destroy():void
	{
		clip.parent.removeChild(clip); 
		
	}
}
}