﻿// PARTICLE EXPERIMENTS
// Author : Seb Lee-Delisle
// Blog : www.sebleedelisle.com
// Company : www.pluginmedia.net
//
// This work is licensed under a Creative Commons  2.0 License.

// Full details at 
// http://creativecommons.org/licenses/by/2.0/uk/

// You may re-use this code as you wish, but a credit would be 
// appreciated. And I'd love to see what you do with it! 
// mail me : seb@sebleedelisle.com

package{
	

import flash.filters.*;
import flash.display.*; 

public class Particle3D { 

	var xVel:Number;
	var yVel:Number;
	var zVel:Number;
	
	public var x:Number;
	public var y:Number;
	public var z:Number
	public var scale:Number;
	
	public var drag:Number = 1;
	public var fade:Number = 0;
	public var shrink:Number = 1;
	public var gravity:Number = 0;
	
	public static var centreX:Number;
	public static var centreY:Number;

	static var fov:Number = 250;
	static var pCount:Number =0;
	
	public var clip:Sprite;
	
	var blurFilter:BlurFilter;
	var filterArray:Array;
	
	public function Particle3D(classref:Class, targetclip:DisplayObjectContainer, xpos:Number, ypos:Number, zpos:Number, depth:Number){

		clip = new classref(); 
		targetclip.addChild(clip); 

		x = xpos;
		y = ypos;
		z = zpos;
		scale = 1; 
		xVel = 0;
		yVel = 0;
		zVel = 0;
		
		blurFilter = new BlurFilter(0, 0, 1);
		filterArray = [blurFilter];
		
		render();

	}
	
	public function setVel(xvel:Number, yvel:Number, zvel:Number){
		xVel = xvel;
		yVel = yvel;
		zVel = zvel;
	}
	
	
	public function update(){
		
		// add the velocity to the particle's position... 
		x += xVel;
		y += yVel;
		z += zVel;
		
		// apply drag
		xVel*=drag;
		yVel*=drag;
		zVel*=drag;		
		
		// fade out
		//clip.alpha += fade;
		
		// scale
		//clip.scaleX = clip.scaleY *=shrink;
		
		// gravity
		yVel+=gravity;
		
	}
	
	
	public function render(){

		var newscale:Number = fov/(fov+z);
		clip.scaleX = clip.scaleY = newscale*scale;
		
		clip.x = centreX+x*newscale;
		clip.y = centreY+y*newscale;

		/*trace(clip+" "+newscale+" "+scale);
		trace(clip.x+" "+clip.y+" " +clip.alpha+ " "+clip.visible+" "+clip.scaleX+" "+clip.scaleY); 
		trace(x+" "+y+" "+z); 
		trace(centreX+" "+centreY); 
		*/
		
		
		
		/*
		var newdepth:Number= Math.round(10000-z*2000);
		while(clip._parent.getInstanceAtDepth(newdepth)) newdepth--;
		clip.swapDepths(newdepth);

		if(clip._width<60){
			var blurAmount = (-z/10);
			if(blurAmount>=1){
				blurFilter.blurX = blurAmount;
				blurFilter.blurY = blurAmount;
				
				clip.filters = filterArray;
			} else {
				clip.filters = new Array();
			}
		} else {
			clip.filters = new Array();
		}
		*/

	}
	
	public function rotateY(value:Number){

		var cosRY:Number = Math.cos(value* Math.PI / 180);
		var sinRY:Number = Math.sin(value* Math.PI / 180);
		
		var tempX:Number = x;
		x= (tempX*cosRY)+(z*sinRY);
		z= (tempX*-sinRY)+(z*cosRY);
		
		tempX = xVel;
		
		xVel= (tempX*cosRY)+(zVel*sinRY);
		zVel= (tempX*-sinRY)+(zVel*cosRY);


	}
	
	/*public function destroy(){
		if(clip.getDepth()<=0) {
			var emptydepth:Number = 20000;
			while(clip._parent.getInstanceAtDepth(emptydepth)) emptydepth++;
			clip.swapDepths(emptydepth);
	
		}
		
		clip.removeMovieClip();
	}*/
}
}